' TabControl 1.5.2
' Provides XP style tabs to control Dynamic, Inline Frames or PostBack page content naivgation.
' Written by Hunter Beanland

'1.5.2 default tab height now 25px
'1.5.1 tab image valign, xhtml compliance fixes "'"
'1.5 Persisted TabSelected between page postings. Fixed XHTML tab width settings
'1.4 Added ClearTabs, UseHand, onTabSelected event.
'1.3 Added selectTab javascript function; Scroll property for frames and Dynamic (also enforces div height).

Imports System
Imports System.ComponentModel
Imports System.Collections
Imports System.Collections.Specialized
Imports System.Web
Imports System.Web.UI
Imports System.Text
Imports Microsoft.VisualBasic

Namespace Bean.Controls
    <ToolboxData("<{0}:TabControl runat=server></{0}:TabControl>")> _
    Public Class TabControl
        Inherits System.Web.UI.WebControls.WebControl
        Implements IPostBackEventHandler

        Private TabListText(0) As String 'only 1 dimension is serialisable in the viewstate
        Private TabListIcon(0) As String
        Private TabListAction(0) As String
        Private RowList(0) As Int16
        Private _TabCount As Int16 = 0
        Private _Height As String = "80%" '% or px
        Private _Width As String = "100%" '% or px
        Private _TabWidth As String = String.Empty 'px
        Private _TabHeight As String = "25" 'px
        Private _BGColor As String = "#FFFFFF" 'named or # hex
        Private _TabType As TabTypes = TabTypes.Dynamic
        Private _TabSelected As Int16 = 0
        Private _ControlImagePath As String = "TabControl/"
        Private _ControlScriptPath As String = "TabControl/"
        Private _TabHome As Boolean = False
        Private _Scroll As Boolean = Nothing
        Private _UseHand As Boolean = True
        Private _ApplyContentStyle As Boolean = False
        Private _OnClick As String = String.Empty
        Public Enum TabTypes
            Frames = 1
            PostBack = 2
            Dynamic = 3
        End Enum
        Public Event onTabSelected(ByVal TabIndex As Int16) 'Postback type only

        <Bindable(True), Category("Data"), DefaultValue(TabTypes.Dynamic)> Property TabType() As TabTypes
            Get
                Return _TabType
            End Get
            Set(ByVal Value As TabTypes)
                _TabType = Value
            End Set
        End Property

        <Bindable(True), Category("Data"), DefaultValue(1)> Property TabSelected() As Int16
            Get
                If _TabSelected = 0 Then
                    If IsNothing(HttpContext.Current.Request.Form(Me.UniqueID & "TabSelected")) Then
                        _TabSelected = 1
                    Else
                        _TabSelected = HttpContext.Current.Request.Form(Me.UniqueID & "TabSelected")
                    End If
                End If
                Return _TabSelected
            End Get
            Set(ByVal Value As Int16)
                _TabSelected = Value
            End Set
        End Property

        <Bindable(True), Category("Data"), DefaultValue(0)> Property TabCount() As Int16
            Get
                Return _TabCount
            End Get
            Set(ByVal Value As Int16)
            End Set
        End Property

        <Bindable(True), Category("Data"), DefaultValue("/Images/")> Property ControlImagePath() As String
            Get
                Return _ControlImagePath
            End Get
            Set(ByVal Value As String)
                _ControlImagePath = Value
            End Set
        End Property

        <Bindable(True), Category("Data"), DefaultValue("/JS/")> Property ControlScriptPath() As String
            Get
                Return _ControlScriptPath
            End Get
            Set(ByVal Value As String)
                _ControlScriptPath = Value
            End Set
        End Property

        <Bindable(True), Category("Appearance"), DefaultValue("80%")> Property ContentHeight() As String
            Get
                Return _Height
            End Get
            Set(ByVal Value As String)
                _Height = Value
            End Set
        End Property

        <Bindable(True), Category("Appearance"), DefaultValue("100%")> Property ContentWidth() As String
            Get
                Return _Width
            End Get
            Set(ByVal Value As String)
                _Width = Value
            End Set
        End Property

        <Bindable(True), Category("Appearance"), DefaultValue("")> Property TabWidth() As String
            Get
                Return _TabWidth
            End Get
            Set(ByVal Value As String)
                _TabWidth = Value
            End Set
        End Property

        <Bindable(True), Category("Appearance"), DefaultValue("25")> Property TabHeight() As String
            Get
                Return _TabHeight
            End Get
            Set(ByVal Value As String)
                _TabHeight = Value
            End Set
        End Property

        <Bindable(True), Category("Appearance"), DefaultValue("#FFFFFF")> Property BGColor() As String
            Get
                Return _BGColor
            End Get
            Set(ByVal Value As String)
                _BGColor = Value
            End Set
        End Property

        <Bindable(True), Category("Appearance"), DefaultValue(False)> Property TabHome() As Boolean
            Get
                Return _TabHome
            End Get
            Set(ByVal Value As Boolean)
                _TabHome = Value
            End Set
        End Property

        <Bindable(True), Category("Appearance")> Property Scroll() As Boolean
            Get
                Return _Scroll
            End Get
            Set(ByVal Value As Boolean)
                _Scroll = Value
            End Set
        End Property

        <Bindable(True), Category("Appearance")> Property UseHand() As Boolean
            Get
                Return _UseHand
            End Get
            Set(ByVal Value As Boolean)
                _UseHand = Value
            End Set
        End Property

        <Bindable(True), Category("Appearance"), DefaultValue(True)> Property ApplyContentStyle() As Boolean
            Get
                Return _ApplyContentStyle
            End Get
            Set(ByVal Value As Boolean)
                _ApplyContentStyle = Value
            End Set
        End Property

        <Bindable(True), Category("Data"), DefaultValue("")> Property OnClick() As String
            Get
                Return _OnClick
            End Get
            Set(ByVal Value As String)
                _OnClick = Value.Replace("""", "'")
            End Set
        End Property

        Public Sub SaveToViewState()
            'Save the local vars to the viewstate
            'Can't do this in the individual properties as some vars do not have a public property
            'and the arrays should only be serialised/deserialised once
            ViewState("TabListText") = TabListText
            ViewState("TabListIcon") = TabListIcon
            ViewState("TabListAction") = TabListAction
            ViewState("RowList") = RowList
            ViewState("TabCount") = _TabCount
            ViewState("Height") = _Height
            ViewState("Width") = _Width
            ViewState("TabWidth") = _TabWidth
            ViewState("TabHeight") = _TabHeight
            ViewState("BGColor") = _BGColor
            ViewState("TabType") = _TabType
            'ViewState("TabSelected") = TabSelected
            ViewState("ControlImagePath") = _ControlImagePath
            ViewState("ControlScriptPath") = _ControlScriptPath
            ViewState("TabHome") = _TabHome
            ViewState("Scroll") = _Scroll
            ViewState("UseHand") = _UseHand
            ViewState("ApplyContentStyle") = _ApplyContentStyle
            ViewState("OnClick") = _OnClick
        End Sub

        Protected Overrides Sub LoadViewState(ByVal savedState As Object)
            'Load the viewstate when it becomes available into our vars
            MyBase.LoadViewState(savedState)
            TabListText = CType(ViewState("TabListText"), Array)
            TabListIcon = CType(ViewState("TabListIcon"), Array)
            TabListAction = CType(ViewState("TabListAction"), Array)
            RowList = CType(ViewState("RowList"), Array)
            Int16.TryParse(ViewState("TabCount"), _TabCount)
            _Height = ViewState("Height")
            _Width = ViewState("Width")
            _TabWidth = ViewState("TabWidth")
            _TabHeight = ViewState("TabHeight")
            _BGColor = ViewState("BGColor")
            Dim intTabType As Integer
            Integer.TryParse(ViewState("TabType"), intTabType)
            _TabType = intTabType
            'TabSelected = Int16.Parse(ViewState("TabSelected"))
            _ControlImagePath = ViewState("ControlImagePath")
            _ControlScriptPath = ViewState("ControlScriptPath")
            Boolean.TryParse(ViewState("TabHome"), _TabHome)
            Boolean.TryParse(ViewState("Scroll"), _Scroll)
            Boolean.TryParse(ViewState("UseHand"), _UseHand)
            Boolean.TryParse(ViewState("ApplyContentStyle"), _ApplyContentStyle)
            _OnClick = ViewState("OnClick")
        End Sub

        Public Sub RaisePostBackEvent(ByVal eventArgument As String) Implements IPostBackEventHandler.RaisePostBackEvent
            'PostBack occured. Set the new tab
            If IsNumeric(eventArgument) Then TabSelected = Integer.Parse(eventArgument)
            RaiseEvent onTabSelected(TabSelected)
        End Sub

        '''<summary>
        '''Adds a tab to control
        '''</summary>
        '''<param name="TabText">Text to appear on the tab</param>
        '''<param name="TabImage">Optional. Relative URL of an image for the tab.</param>
        '''<param name="TabIDAction">For Dynamic: Tag ID of the associated DIV (or TABLE etc). For Inline Frames: URL/page file name, PostBack: blank.</param>
        Public Sub AddTab(ByVal TabText As String, ByVal TabImage As String, ByVal TabIDAction As String)
            'Add the tab data to our array
            _TabCount = _TabCount + 1
            ReDim Preserve TabListText(_TabCount)
            ReDim Preserve TabListIcon(_TabCount)
            ReDim Preserve TabListAction(_TabCount)
            TabListText(_TabCount) = TabText
            TabListIcon(_TabCount) = TabImage
            TabListAction(_TabCount) = TabIDAction
        End Sub

        '''<summary>
        '''Clear the tabs already set
        '''</summary>
        Public Sub ClearTabs()
            _TabCount = 0
            ReDim TabListText(0)
            ReDim TabListIcon(0)
            ReDim TabListAction(0)
        End Sub

        '''<summary>
        '''Marks when a new row of tabs should be inserted
        '''</summary>
        Public Sub NewRow()
            'Add new row marker to next tab
            ReDim Preserve RowList(UBound(RowList) + 1)
            RowList(UBound(RowList)) = _TabCount + 1
        End Sub

        '''<summary>
        '''Selects the default tab by the text which appears on it
        '''</summary>
        '''<param name="TabText">Text which appears on the desired tab</param>
        Public Sub SelectTabName(ByVal TabText As String)
            'Select a tab via it's name
            Dim intLoop As Int16
            For intLoop = 1 To UBound(TabListText, 1)
                If TabText = TabListText(intLoop) Then
                    TabSelected = intLoop
                    Exit For
                End If
            Next
        End Sub

        Protected Overrides Sub OnPreRender(ByVal e As EventArgs)
            'Build and register all the scripts
            If _TabCount = 0 Then Exit Sub
            If TabSelected > _TabCount Then TabSelected = _TabCount
            If TabSelected < 1 Then TabSelected = 1
            Dim intCurrTab As Int16
            Dim sb As New StringBuilder()
            If Not Page.ClientScript.IsClientScriptBlockRegistered(Me.UniqueID & "VTabControlInit") Then
                'Init js variables
                sb.Append("<script type='text/javascript'>TabControlID=""" & Me.ClientID & """; ")
                sb.Append("TabImagePath=""" & ControlImagePath & """; ")
                sb.Append("intTabType=" & _TabType & "; ")
                sb.Append("strHeight=""" & _Height & """; ")
                sb.Append("strWidth=""" & _Width & """; ")
                sb.Append("strOnClick=""" & _OnClick & """; ")
                sb.Append("strPrevTab=""" & TabSelected & """; ")
                sb.Append("strPrevContentID=""")
                If TabType = TabTypes.Frames Then
                    sb.Append("TabContent" & TabSelected & """;" & vbLf)
                Else
                    sb.Append(TabListAction(TabSelected) & """;")
                End If
                sb.Append("var tabList = new Array(")
                For intCurrTab = 1 To UBound(TabListText)
                    If intCurrTab > 1 Then sb.Append(",")
                    sb.Append("'" & TabListAction(intCurrTab) & "'")
                Next
                sb.Append(");")
                sb.Append("</script>" & vbLf)
                Page.ClientScript.RegisterClientScriptBlock(Me.GetType(), Me.UniqueID & "VTabControlInit", sb.ToString)
            End If
            If Not Page.ClientScript.IsClientScriptBlockRegistered("VTabControlJS") Then
                'Style and JS libraries
                Page.ClientScript.RegisterClientScriptBlock(Me.GetType(), "VTabControlCSS", "<style>.Tab { font-weight:normal; font-size:8pt; cursor:default; color:#0000ff; font-style:normal; font-family:""MS Sans Serif"", Arial, sans-serif; text-align:center; }" & vbLf & _
                    ".TabContent { border-left:solid 1px #919B9C; border-bottom:solid 1px #919B9C; border-right:solid 1px #919B9C; }</style>" & vbLf)
                Page.ClientScript.RegisterClientScriptBlock(Me.GetType(), "VTabControlJS", "<script type='text/javascript' src='" & ControlScriptPath & "tabcontrol.js'></script>")
            End If
            'Start script - run after all controls are rendered
            sb.Length = 0
            sb.Append("<script type='text/javascript'>tabInit(); ")
            If _TabType = TabTypes.Dynamic Then
                For intCurrTab = 1 To UBound(TabListAction)
                    If intCurrTab <> TabSelected Then
                        sb.Append("document.getElementById(""" & TabListAction(intCurrTab) & """).style.display='none';")
                    Else
                        sb.Append("document.getElementById(""" & TabListAction(intCurrTab) & """).style.display='block';")
                    End If
                    If _ApplyContentStyle Then
                        sb.Append("document.getElementById(""" & TabListAction(intCurrTab) & """).className='TabContent';")
                        'sb.Append("document.getElementById(""" & TabListAction(intCurrTab) & """).style.width='" & _Width & "';")
                        sb.Append("document.getElementById(""" & TabListAction(intCurrTab) & """).style.height='" & _Height & "';")
                    End If
                    If IsNothing(_Scroll) Then
                        'none
                    ElseIf _Scroll Then
                        sb.Append("document.getElementById(""" & TabListAction(intCurrTab) & """).style.clip='rect(auto,auto," & _Height & "," & _Width & ")';")
                        sb.Append("document.getElementById(""" & TabListAction(intCurrTab) & """).style.overflow='scroll';")
                    Else
                        'none - default
                    End If
                    sb.Append(vbLf)
                Next
            ElseIf _TabType = TabTypes.Frames And Not Page.ClientScript.IsClientScriptBlockRegistered("VTabControlSS") Then
                If _Height = "*" Or _Width = "*" Then sb.Append("window.onresize+=resizeTabControl; window.onload+=resizeTabControl;")
            End If
            If Not Page.ClientScript.IsClientScriptBlockRegistered(Me.UniqueID & "VTabControlSS") Then
                sb.Append("</script>" & vbLf)
                Page.ClientScript.RegisterStartupScript(Me.GetType(), Me.UniqueID & "VTabControlSS", sb.ToString)
            End If
            SaveToViewState()
        End Sub

        Protected Overrides Sub Render(ByVal output As System.Web.UI.HtmlTextWriter)
            'Write out our control
            Dim strImageBase As String
            Dim intCurrTab, intRow As Int16
            If _TabCount = 0 Then
                output.Write("No tabs added to Tab Control!")
            End If
            output.Write("<table bgcolor='" & BGColor & "' id='" & Me.ClientID & "TabControl' cellpadding='0' cellspacing='0' border='0'>" & vbLf) ' width='" & _Width & "'
            output.Write("<tr><td>" & vbLf) 'style=""background-Image:url('" & _ControlImagePath & "tab_nothing.gif');""
            output.Write("<table bgcolor='" & _BGColor & "' cellpadding='0' cellspacing='0' border='0'><tr>" & vbLf)
            'Home button
            If _TabType = TabTypes.Frames And _TabHome Then
                output.Write("<td background='" & _ControlImagePath & "tab_nothing.gif'>&nbsp;<a href='javascript:tabHome();'><img src='" & _ControlImagePath & "tab_home.gif' border='0' alt='' /></a>&nbsp;&nbsp;&nbsp;</td>" & vbLf)
            End If

            For intCurrTab = 1 To UBound(TabListText)
                'Tab or or off?
                If intCurrTab = TabSelected Then
                    strImageBase = _ControlImagePath & "tab_on_"
                Else
                    strImageBase = _ControlImagePath & "tab_off_"
                End If
                'Start new row?
                For intRow = 1 To UBound(RowList)
                    If RowList(intRow) = intCurrTab Then
                        output.Write("</tr></table><table bgcolor='" & _BGColor & "' cellpadding='0' cellspacing='0' border='0'><tr>" & vbLf)
                    End If
                Next
                'Start tab
                output.Write("<td id='TabLeft" & intCurrTab & "' nowrap style=""width:4px;background-Image:url('" & strImageBase & "left.gif');"">&nbsp;</td>" & vbLf)
                'Middle of Tab
                output.Write("<td id=TabMid" & intCurrTab & " class='Tab' valign='middle' style=""height:" & _TabHeight & "px;")
                If _TabWidth <> String.Empty Then output.Write("width:" & _TabWidth & "px;")
                If _UseHand Then
                    output.Write("cursor:pointer;cursor:hand;")
                End If
                output.Write("background-Image:url('" & strImageBase & "mid.gif');"" nowrap onmouseover='TabOver(this)' onmouseout='TabOver(this)' ")
                If _TabType = TabTypes.Dynamic Then output.Write("onclick=""changeTabs(this, '" & TabListAction(intCurrTab) & "');"">")
                If _TabType = TabTypes.PostBack Then output.Write("onclick=""" & Page.ClientScript.GetPostBackEventReference(Me, intCurrTab) & """>")
                If _TabType = TabTypes.Frames Then output.Write("onclick=""changeTabs(this, 'TabContent" & intCurrTab & "');"">")
                If TabListIcon(intCurrTab) <> String.Empty Then
                    'Insert icon and v-align text
                    output.Write("<img src='" & TabListIcon(intCurrTab) & "' align='absmiddle' border='0' alt='' style='position:relative; top:1px;' /> ")
                End If
                output.Write(TabListText(intCurrTab) & "</td>" & vbLf) '<span style='position:relative; top:-3px;'> 
                'End tab
                output.Write("<td id='TabRight" & intCurrTab & "' nowrap='nowrap' style=""width:4px;background-Image:url('" & strImageBase & "right.gif');"">&nbsp;</td>" & vbLf)
            Next

            'End spacer
            output.Write("</tr></table>" & vbLf)
            output.Write("</td><td style=""width:100%;background-Image:url('" & _ControlImagePath & "tab_nothing.gif');""></td></tr></table>" & vbLf)

            'Content Area
            If _TabType = TabTypes.Frames Then
                For intCurrTab = 1 To UBound(TabListAction)
                    output.Write("<iframe ")
                    If IsNothing(_Scroll) Then
                        'auto
                    ElseIf _Scroll Then
                        output.Write("scrolling='yes' ")
                    Else
                        output.Write("scrolling='no' ")
                    End If
                    If _Width <> "*" Then
                        output.Write("width='" & _Width & "' ")
                    Else
                        output.Write("width='100%' ")
                    End If
                    If _Height <> "*" Then
                        output.Write("height='" & _Height & "' ")
                    Else
                        output.Write("height='95%' ")
                    End If
                    output.Write("id='TabContent" & intCurrTab & "' name='TabContent" & intCurrTab & "' src='" & TabListAction(intCurrTab) & "' frameborder=0")
                    If intCurrTab = TabSelected Then
                        output.Write(" style='display:block;'")
                    Else
                        output.Write(" style='display:none;'")
                    End If
                    If _ApplyContentStyle Then
                        output.Write(" class='TabContent'")
                    End If
                    output.Write(">No IFrame Support!</iframe>" & vbLf)
                Next
            End If
            output.Write("<input type='hidden' id='" & Me.ClientID & "TabSelected' name='" & Me.UniqueID & "TabSelected' value='" & TabSelected & "' />")
        End Sub
    End Class
End Namespace
